Page MenuHomePhabricator

Sort out concept for overview/entrance pages targeting our developer audience
Closed, ResolvedPublic

Description

This task belonged to a goal committed for Developer-Advocacy (Oct-Dec 2017).

Completion of a first pass to our documentation for new developers in MediaWiki.org, structuring pages, updating and cleaning information. Test the refreshed docs with Outreachy Round 15 and Google Code-in 2017 participants, and review accordingly.

Situation:
We have a good bunch of pages and resources [partially] targetting [new] developers:

Problems (not a complete list, feel free to add):

  • Different established community members send potential new contributors to different pages due to unclear scope differentiation.
  • Pages are text deserts with gazillions of links, overwhelming anyone who just wants to get stuff done.
  • Some concepts work better/worse than others (e.g. having mentors via Featured Projects vs 'You're pretty much on your own' via Annoying Little Bugs) and we don't communicate these different concepts to potential new contributors to allow judging themselves ("Do I need more handholding or do I prefer to find my way on my own?")

Goal:
Allow potential new contributors to succeed more often by

  • having pages which offer a clear contribution path forward and guide the new contributor
  • having pages with a clearer, communicated scope
  • communicating that pages which are link collections are not "guides" or "tutorials" or such (but maybe "resource hubs" or whatever)
  • potentially reducing the number of pages targeting similar audiences
  • making people feel responsible to garden some pages, also against well-meant attempts to add more and more content / links

Related Objects

StatusAssignedTask
Resolvedsrishakatux
ResolvedAklapper
ResolvedNone
Resolvedsrishakatux
Resolvedsrishakatux
ResolvedAklapper
Resolvedsrishakatux
Resolvedsrishakatux
ResolvedNone
ResolvedAklapper
ResolvedAklapper
ResolvedAklapper
ResolvedAklapper
ResolvedAklapper
ResolvedAklapper
ResolvedAklapper
DeclinedAklapper
ResolvedAklapper
ResolvedAklapper
ResolvedAklapper
ResolvedAklapper
Resolvedsrishakatux

Event Timeline

There are a very large number of changes, so older changes are hidden. Show Older Changes

As discussed, we need somewhere a task to organize the changes in the mediawiki.org homepage

Here it is T170349

All this looks like a solid plan! :) Adding a few thoughts below, warning.. some of the stuff might be beyond the scope of this task but a related discussion:

Thanks!

  • How to contribute page from navigation & design perspective -- this page seems to have duplicate links in the top navigation & in the content body (e.g. tech forum, tech news, etc.) Also “Wikimedia Technology” & “Wikimedia Audiences” sounds like buzz words. They could perhaps be merged with the product development page. This page also has too many categories that could be reduced.

Totally agree. As an interested new contributor I have no idea what all these items are, if they are relevant for me, if I should click them to get more confused.

  • IMO Newcomer portal only be a step-by-step guide to help a new developer finish a task. And, all the other stuff like communication, outreach programs, etc. can be linked from How to Contribute page itself. We also have an opportunity here to think about offering a newwww newcomer channel and mailing list which we make clearly accessible from the portal. Visualizing... something like this >

Yes. Trying to list "must haves", not "can haves".
(Example: "It is always better to follow and share the news of MediaWiki across your social network." makes me scream "No it is not").

However where to list "other stuff" (additional resources) depends on who we target on which page.
Random made up example: Not much sense to list for example "wikitech-l@" on "How to contribute" if you're into translating the UI?

That screenshot looks neat. Not like the rest of the grey 1990es.

  • Introduction to Wikimedia tech -- happy to help prepare content for this, work with comms and develop a video with voiceover, subtitles, etc. as I shared on our cep list once. Something like this.
  • Page names IMO:
    • “Newcomers” sounds more friendly than “New Developers.”

True, however good terms are already overloaded (think "project"). I don't want to confuse and mislead. I can be a newcomer in many different ways. This page explicitly targets new developers. Newcomers (in whatever areas) should go to How_to_contribute.

  • “Contribute” sounds better than “How to contribute”. Same goes for our other pages that start with "How to..".
  • I killed "Starter kit" (see its old version here) and redirected it to "How to contribute".
    • The intro was useful hence I copied it into [[How to contribute]].
    • I copied recommending to register an account on mediawiki.org and info how to edit, discussing, and your user page into [[How to contribute]].
    • "Communication" listed both passive following ("social media") and actual conversations (IRC, mailing lists). Shortened version copied to [[How to contribute]].
    • Some parts in the "Hacking" section were useful, hence copied into into [[How to contribute]].
    • I don't see why it listed wikitech-announce@. That's for admins/high-level mostly? I don't follow that list, why should someone else?! Why not Tech News instead?
    • The page was linked at the top of [[How to contribute]]. Just to link back to where you came from for "Check the areas to contribute". That did not make sense.
    • Explaining Phabricator and Gerrit was irrelevant at this stage. I only need to know that if I decide to start hacking on projects and on projects which actually use them, hence nothing for a generic "Starter Kit". That stuff is covered by [[How to become a MediaWiki hacker]] already which is linked from [[How to contribute]].
    • QA and API and Translation were already listed on [[How to contribute]], needlessly duplicating content and stuff I'm supposed to read.
    • Again, running MediaWiki and Vagrant is only relevant if I decide to start hacking on projects which require MediaWiki itself, hence nothing for a generic "Starter Kit". That stuff is covered by [[How to become a MediaWiki hacker]] already which is linked from [[How to contribute]].
    • Learning how to use the MediaWiki software is only relevant here if I decide to start hacking on projects which require MediaWiki itself. That's covered by [[How to become a MediaWiki hacker]] already which is linked from [[How to contribute]].
Aklapper updated the task description. (Show Details)Jul 14 2017, 5:51 PM

Note to myself: The replies under "What did you find most confusing about the existing Wikimedia technical documentation?" on mw:Hackathon 2017's Questions for newcomers probably also fuel T156301 and this task. For example "if I look for an short answer - I get also a lot background infos on the actual topic".

Aklapper updated the task description. (Show Details)Jul 20 2017, 4:33 PM

...and Rachel just pointed to https://www.mediawiki.org/wiki/Hackathon/Laptop_setup . Which I had not seen before. Which looks great, great, great. (Apart from the fact that a few projects do not use Wikimedia infrastructure like Gerrit/Phab etc, but generally it's beautifully clean).

Aklapper added a comment.EditedAug 14 2017, 11:42 AM

Note to myself: Once videos are available, go through learnings from GUADEC 2017 conference about GNOME's Newcomers page from session https://2017.guadec.org/talks-and-events/#abstract-48-newcomer_genesis_evolution - page design, IRC bridging, etc
Slides at https://blogs.gnome.org/bastian/files/2017/07/Newcomer-Genesis-Evolution2.pdf

Edit: Video is at https://www.youtube.com/watch?v=s2o4fzoCljk

Aklapper updated the task description. (Show Details)Sep 4 2017, 11:57 AM

Added information about the technical advice meeting on the New Developers page.

Qgil added a comment.Sep 5 2017, 7:58 PM

Technical Advice IRC Meeting|'''Join us for the weekly technical advice meetings every Wednesday from 3 to 4 pm UTC on #wikimedia-tech''

#wikimedia-tech and not #wikimedia-devrel?

So... I believe that understanding and defining which pages should be Tutorials vs How-Tos vs References is the key.
I urge anybody to read https://www.divio.com/en/blog/documentation/ (pretty much the talk I attended at Write The Docs conference).

This task will expand to October.

Qgil added a project: Goal.Oct 4 2017, 8:18 AM
Qgil moved this task from Backlog to Ready to Go on the Developer-Advocacy (Oct-Dec 2017) board.

....and dropping a quote from an email by bd808 here, so it's not forgotten in my inbox:

[[How_to_become_a_MediaWiki_hacker]] [...] I was really struck by a few things:

  • Its about more than MediaWiki, but you need to read in pretty far to figure that out.
  • The TOC is a big scary wall of keywords that are probably foreign to most actual newcomers to the community.
  • Making LDAP accounts, Gerrit, and MediaWiki-Vagrant the jumping in point might not really be the best introduction to our larger world.
  • Code of Conduct is only mentioned in the "See also" section.

and Quiddity mentioned https://www.mediawiki.org/wiki/User:Quiddity_(WMF)/Hubs_and_docs as an overview

Work continues in Q1 2018 hence updating project tag.

Liked the approach of "Mentored" and "PatchWelcome" bugs that I discovered here: https://wiki.mozilla.org/Webdev/GetInvolved/developer.mozilla.org#Mentored_Bugs. We could also consider experimenting with this model.

@srishakatux: I am very reluctant because of T78639#1932603.

Restricted Application added a subscriber: Zoranzoki21. · View Herald TranscriptMar 1 2018, 11:48 AM
Aklapper updated the task description. (Show Details)
Aklapper added a subscriber: srodlund.
Aklapper updated the task description. (Show Details)Nov 8 2018, 3:25 AM

Finally digitalized the drawing on my table that describes the current situation.
Straight arrows (⟶): Page directly advertises another page.
Dashed arrows (⤏): Pages mentioned under "Additional resources" or "if you are looking for XYZ instead / if your skills are XYZ instead".
One could add a billion more pages I guess (see list in task description).

Didn't check WRC (hence no arrows) as I get lost and see lots of non-dev stuff under "For Developers" (for example, "Frequently asked questions – Participation: Learn more about participating on the Wikimedia projects." goes to https://meta.wikimedia.org/wiki/Ask_a_question/FAQ/Participation which is entirely about content which feels out of scope if I am into code).

Aklapper removed Aklapper as the assignee of this task.Jul 15 2019, 4:51 PM
Aklapper raised the priority of this task from Normal to Needs Triage.
srishakatux closed this task as Resolved.Aug 22 2019, 10:17 AM
srishakatux claimed this task.

(this task served its purpose! closing it now <3)

srishakatux removed srishakatux as the assignee of this task.Aug 22 2019, 10:17 AM
srishakatux awarded a token.